VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "clsControlResizer"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
'@author: ionut.brihacel@rationalsoftware.ro
Public ctr As Object
Private mCol As Collection

Public Enum enPositionType
    enDoNothing = 0
    enFixedLeft = 1
    enFixedTop = 2
    enFixedRight = 4
    enFixedBottom = 8
    enResizeWidth = 5
    enResizeHeight = 10
    enResizeAll = 15
    
End Enum
Public PosType As Integer
Public InitialTop As Long
Public InitialLeft As Long
Public InitialWidth As Long
Public InitialHeight As Long
Public InitialRight As Long
Public InitialBottom As Long
Public Property Get ContainedControlsCollection() As Collection
Set ContainedControlsCollection = mCol

End Property

Public Property Get ContainedControlsCount() As Long
If Not mCol Is Nothing Then
    ContainedControlsCount = mCol.Count
End If
End Property


Public Property Get Key() As String
On Error Resume Next
Key = GetControlKeyName(ctr)

End Property
Private Function GetControlKeyName(ctr As Object) As String
On Error Resume Next
s = ctr.Name
s = ctr.Name & "." & ctr.Name & "." & ctr.Index
GetControlKeyName = s
End Function
Public Function SetMyControl(ctr As Object) As clsControlResizer
Dim s As String
Dim c As clsControlResizer
Set c = Me



Set c.ctr = ctr
c.InitialHeight = ctr.Height
c.InitialLeft = ctr.Left
c.InitialTop = ctr.Top
c.InitialWidth = ctr.Width
c.InitialBottom = Me.Height - c.Top - c.Height
c.InitialRight = Me.Width - c.Left - c.Width

c.PosType = PosType
Set SetMyControl = c
End Function

Function AddControl(ctr As Object, PosType As Integer) As clsControlResizer
If mCol Is Nothing Then Set mCol = New Collection

Dim s As String
Dim c As clsControlResizer
Set c = New clsControlResizer
Set c.ctr = ctr
c.InitialHeight = ctr.Height
c.InitialLeft = ctr.Left
c.InitialTop = ctr.Top
c.InitialWidth = ctr.Width
c.InitialBottom = Me.Height - c.Top - c.Height
c.InitialRight = Me.Width - c.Left - c.Width

c.PosType = PosType
mCol.Add c, c.Key
Set AddControl = c

End Function
Function ResizeContainedControls()
On Error Resume Next
Dim c As clsControlResizer
For Each c In mCol
If c.PosType And enPositionType.enFixedRight Then
    If c.PosType And enPositionType.enFixedLeft Then
    c.Width = Me.Width - c.Left - c.InitialRight
    
    Else
    c.Left = Me.Width - c.Width - c.InitialRight
    
    End If

End If
If c.PosType And enPositionType.enFixedBottom Then
    If c.PosType And enPositionType.enFixedTop Then
    c.Height = Me.Height - c.Top - c.InitialBottom
    Else
    c.Top = Me.Height - c.Height - c.InitialBottom
    End If

End If

If c.ContainedControlsCount > 0 Then c.ResizeContainedControls


Next
End Function
Public Property Get Height() As Long
On Error Resume Next
Dim X As Long
X = ctr.Height
X = ctr.ScaleHeight
Height = X
End Property
Public Property Get Width() As Long
On Error Resume Next
Dim X As Long
X = ctr.Width
X = ctr.ScaleWidth
Width = X
End Property
Public Property Get Top() As Long
Top = ctr.Top
End Property
Public Property Get Left() As Long
Left = ctr.Left
End Property
Public Property Let Left(X As Long)
ctr.Left = X
End Property
Public Property Let Top(X As Long)
ctr.Top = X
End Property
Public Property Let Width(X As Long)
ctr.Width = X
End Property
Public Property Let Height(X As Long)
ctr.Height = X
End Property

